<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FINANCE_APPLICATIONResult StructType
 * @subpackage Structs
 */
class FINANCE_APPLICATIONResult extends AbstractStructBase
{
    /**
     * The AccountNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $AccountNumber;
    /**
     * The Apr
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Apr;
    /**
     * The CofirstName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CofirstName;
    /**
     * The ColastName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $ColastName;
    /**
     * The CreditLimit
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CreditLimit;
    /**
     * The CreditLinePhoneNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CreditLinePhoneNumber;
    /**
     * The CustomerSupportPhoneNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $CustomerSupportPhoneNumber;
    /**
     * The FirstName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $FirstName;
    /**
     * The LastName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $LastName;
    /**
     * The KeyNumber
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $KeyNumber;
    /**
     * The RiskTier
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $RiskTier;
    /**
     * The SecondaryProgramName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $SecondaryProgramName;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Status;
    /**
     * The TimeToCall
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $TimeToCall;
    /**
     * Constructor method for FINANCE_APPLICATIONResult
     * @uses FINANCE_APPLICATIONResult::setAccountNumber()
     * @uses FINANCE_APPLICATIONResult::setApr()
     * @uses FINANCE_APPLICATIONResult::setCofirstName()
     * @uses FINANCE_APPLICATIONResult::setColastName()
     * @uses FINANCE_APPLICATIONResult::setCreditLimit()
     * @uses FINANCE_APPLICATIONResult::setCreditLinePhoneNumber()
     * @uses FINANCE_APPLICATIONResult::setCustomerSupportPhoneNumber()
     * @uses FINANCE_APPLICATIONResult::setFirstName()
     * @uses FINANCE_APPLICATIONResult::setLastName()
     * @uses FINANCE_APPLICATIONResult::setKeyNumber()
     * @uses FINANCE_APPLICATIONResult::setRiskTier()
     * @uses FINANCE_APPLICATIONResult::setSecondaryProgramName()
     * @uses FINANCE_APPLICATIONResult::setStatus()
     * @uses FINANCE_APPLICATIONResult::setTimeToCall()
     * @param string $accountNumber
     * @param string $apr
     * @param string $cofirstName
     * @param string $colastName
     * @param string $creditLimit
     * @param string $creditLinePhoneNumber
     * @param string $customerSupportPhoneNumber
     * @param string $firstName
     * @param string $lastName
     * @param string $keyNumber
     * @param string $riskTier
     * @param string $secondaryProgramName
     * @param string $status
     * @param string $timeToCall
     */
    public function __construct($accountNumber = null, $apr = null, $cofirstName = null, $colastName = null, $creditLimit = null, $creditLinePhoneNumber = null, $customerSupportPhoneNumber = null, $firstName = null, $lastName = null, $keyNumber = null, $riskTier = null, $secondaryProgramName = null, $status = null, $timeToCall = null)
    {
        $this
            ->setAccountNumber($accountNumber)
            ->setApr($apr)
            ->setCofirstName($cofirstName)
            ->setColastName($colastName)
            ->setCreditLimit($creditLimit)
            ->setCreditLinePhoneNumber($creditLinePhoneNumber)
            ->setCustomerSupportPhoneNumber($customerSupportPhoneNumber)
            ->setFirstName($firstName)
            ->setLastName($lastName)
            ->setKeyNumber($keyNumber)
            ->setRiskTier($riskTier)
            ->setSecondaryProgramName($secondaryProgramName)
            ->setStatus($status)
            ->setTimeToCall($timeToCall);
    }
    /**
     * Get AccountNumber value
     * @return string
     */
    public function getAccountNumber()
    {
        return $this->AccountNumber;
    }
    /**
     * Set AccountNumber value
     * @param string $accountNumber
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setAccountNumber($accountNumber = null)
    {
        // validation for constraint: string
        if (!is_null($accountNumber) && !is_string($accountNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accountNumber, true), gettype($accountNumber)), __LINE__);
        }
        $this->AccountNumber = $accountNumber;
        return $this;
    }
    /**
     * Get Apr value
     * @return string
     */
    public function getApr()
    {
        return $this->Apr;
    }
    /**
     * Set Apr value
     * @param string $apr
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setApr($apr = null)
    {
        // validation for constraint: string
        if (!is_null($apr) && !is_string($apr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($apr, true), gettype($apr)), __LINE__);
        }
        $this->Apr = $apr;
        return $this;
    }
    /**
     * Get CofirstName value
     * @return string
     */
    public function getCofirstName()
    {
        return $this->CofirstName;
    }
    /**
     * Set CofirstName value
     * @param string $cofirstName
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setCofirstName($cofirstName = null)
    {
        // validation for constraint: string
        if (!is_null($cofirstName) && !is_string($cofirstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cofirstName, true), gettype($cofirstName)), __LINE__);
        }
        $this->CofirstName = $cofirstName;
        return $this;
    }
    /**
     * Get ColastName value
     * @return string
     */
    public function getColastName()
    {
        return $this->ColastName;
    }
    /**
     * Set ColastName value
     * @param string $colastName
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setColastName($colastName = null)
    {
        // validation for constraint: string
        if (!is_null($colastName) && !is_string($colastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($colastName, true), gettype($colastName)), __LINE__);
        }
        $this->ColastName = $colastName;
        return $this;
    }
    /**
     * Get CreditLimit value
     * @return string
     */
    public function getCreditLimit()
    {
        return $this->CreditLimit;
    }
    /**
     * Set CreditLimit value
     * @param string $creditLimit
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setCreditLimit($creditLimit = null)
    {
        // validation for constraint: string
        if (!is_null($creditLimit) && !is_string($creditLimit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($creditLimit, true), gettype($creditLimit)), __LINE__);
        }
        $this->CreditLimit = $creditLimit;
        return $this;
    }
    /**
     * Get CreditLinePhoneNumber value
     * @return string
     */
    public function getCreditLinePhoneNumber()
    {
        return $this->CreditLinePhoneNumber;
    }
    /**
     * Set CreditLinePhoneNumber value
     * @param string $creditLinePhoneNumber
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setCreditLinePhoneNumber($creditLinePhoneNumber = null)
    {
        // validation for constraint: string
        if (!is_null($creditLinePhoneNumber) && !is_string($creditLinePhoneNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($creditLinePhoneNumber, true), gettype($creditLinePhoneNumber)), __LINE__);
        }
        $this->CreditLinePhoneNumber = $creditLinePhoneNumber;
        return $this;
    }
    /**
     * Get CustomerSupportPhoneNumber value
     * @return string
     */
    public function getCustomerSupportPhoneNumber()
    {
        return $this->CustomerSupportPhoneNumber;
    }
    /**
     * Set CustomerSupportPhoneNumber value
     * @param string $customerSupportPhoneNumber
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setCustomerSupportPhoneNumber($customerSupportPhoneNumber = null)
    {
        // validation for constraint: string
        if (!is_null($customerSupportPhoneNumber) && !is_string($customerSupportPhoneNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerSupportPhoneNumber, true), gettype($customerSupportPhoneNumber)), __LINE__);
        }
        $this->CustomerSupportPhoneNumber = $customerSupportPhoneNumber;
        return $this;
    }
    /**
     * Get FirstName value
     * @return string
     */
    public function getFirstName()
    {
        return $this->FirstName;
    }
    /**
     * Set FirstName value
     * @param string $firstName
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setFirstName($firstName = null)
    {
        // validation for constraint: string
        if (!is_null($firstName) && !is_string($firstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firstName, true), gettype($firstName)), __LINE__);
        }
        $this->FirstName = $firstName;
        return $this;
    }
    /**
     * Get LastName value
     * @return string
     */
    public function getLastName()
    {
        return $this->LastName;
    }
    /**
     * Set LastName value
     * @param string $lastName
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setLastName($lastName = null)
    {
        // validation for constraint: string
        if (!is_null($lastName) && !is_string($lastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastName, true), gettype($lastName)), __LINE__);
        }
        $this->LastName = $lastName;
        return $this;
    }
    /**
     * Get KeyNumber value
     * @return string
     */
    public function getKeyNumber()
    {
        return $this->KeyNumber;
    }
    /**
     * Set KeyNumber value
     * @param string $keyNumber
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setKeyNumber($keyNumber = null)
    {
        // validation for constraint: string
        if (!is_null($keyNumber) && !is_string($keyNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($keyNumber, true), gettype($keyNumber)), __LINE__);
        }
        $this->KeyNumber = $keyNumber;
        return $this;
    }
    /**
     * Get RiskTier value
     * @return string
     */
    public function getRiskTier()
    {
        return $this->RiskTier;
    }
    /**
     * Set RiskTier value
     * @param string $riskTier
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setRiskTier($riskTier = null)
    {
        // validation for constraint: string
        if (!is_null($riskTier) && !is_string($riskTier)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($riskTier, true), gettype($riskTier)), __LINE__);
        }
        $this->RiskTier = $riskTier;
        return $this;
    }
    /**
     * Get SecondaryProgramName value
     * @return string
     */
    public function getSecondaryProgramName()
    {
        return $this->SecondaryProgramName;
    }
    /**
     * Set SecondaryProgramName value
     * @param string $secondaryProgramName
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setSecondaryProgramName($secondaryProgramName = null)
    {
        // validation for constraint: string
        if (!is_null($secondaryProgramName) && !is_string($secondaryProgramName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($secondaryProgramName, true), gettype($secondaryProgramName)), __LINE__);
        }
        $this->SecondaryProgramName = $secondaryProgramName;
        return $this;
    }
    /**
     * Get Status value
     * @return string
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get TimeToCall value
     * @return string
     */
    public function getTimeToCall()
    {
        return $this->TimeToCall;
    }
    /**
     * Set TimeToCall value
     * @param string $timeToCall
     * @return \StructType\FINANCE_APPLICATIONResult
     */
    public function setTimeToCall($timeToCall = null)
    {
        // validation for constraint: string
        if (!is_null($timeToCall) && !is_string($timeToCall)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($timeToCall, true), gettype($timeToCall)), __LINE__);
        }
        $this->TimeToCall = $timeToCall;
        return $this;
    }
}
