<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FINANCE_AUTHORIZATIONResult StructType
 * @subpackage Structs
 */
class FINANCE_AUTHORIZATIONResult extends AbstractStructBase
{
    /**
     * The AuthorizationCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $AuthorizationCode;
    /**
     * The AvsCode
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $AvsCode;
    /**
     * The OFPLanguage
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $OFPLanguage;
    /**
     * The ResponseText
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $ResponseText;
    /**
     * The Status
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Status;
    /**
     * The TransactionId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $TransactionId;
    /**
     * Constructor method for FINANCE_AUTHORIZATIONResult
     * @uses FINANCE_AUTHORIZATIONResult::setAuthorizationCode()
     * @uses FINANCE_AUTHORIZATIONResult::setAvsCode()
     * @uses FINANCE_AUTHORIZATIONResult::setOFPLanguage()
     * @uses FINANCE_AUTHORIZATIONResult::setResponseText()
     * @uses FINANCE_AUTHORIZATIONResult::setStatus()
     * @uses FINANCE_AUTHORIZATIONResult::setTransactionId()
     * @param string $authorizationCode
     * @param string $avsCode
     * @param string $oFPLanguage
     * @param string $responseText
     * @param string $status
     * @param string $transactionId
     */
    public function __construct($authorizationCode = null, $avsCode = null, $oFPLanguage = null, $responseText = null, $status = null, $transactionId = null)
    {
        $this
            ->setAuthorizationCode($authorizationCode)
            ->setAvsCode($avsCode)
            ->setOFPLanguage($oFPLanguage)
            ->setResponseText($responseText)
            ->setStatus($status)
            ->setTransactionId($transactionId);
    }
    /**
     * Get AuthorizationCode value
     * @return string
     */
    public function getAuthorizationCode()
    {
        return $this->AuthorizationCode;
    }
    /**
     * Set AuthorizationCode value
     * @param string $authorizationCode
     * @return \StructType\FINANCE_AUTHORIZATIONResult
     */
    public function setAuthorizationCode($authorizationCode = null)
    {
        // validation for constraint: string
        if (!is_null($authorizationCode) && !is_string($authorizationCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authorizationCode, true), gettype($authorizationCode)), __LINE__);
        }
        $this->AuthorizationCode = $authorizationCode;
        return $this;
    }
    /**
     * Get AvsCode value
     * @return string
     */
    public function getAvsCode()
    {
        return $this->AvsCode;
    }
    /**
     * Set AvsCode value
     * @param string $avsCode
     * @return \StructType\FINANCE_AUTHORIZATIONResult
     */
    public function setAvsCode($avsCode = null)
    {
        // validation for constraint: string
        if (!is_null($avsCode) && !is_string($avsCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($avsCode, true), gettype($avsCode)), __LINE__);
        }
        $this->AvsCode = $avsCode;
        return $this;
    }
    /**
     * Get OFPLanguage value
     * @return string
     */
    public function getOFPLanguage()
    {
        return $this->OFPLanguage;
    }
    /**
     * Set OFPLanguage value
     * @param string $oFPLanguage
     * @return \StructType\FINANCE_AUTHORIZATIONResult
     */
    public function setOFPLanguage($oFPLanguage = null)
    {
        // validation for constraint: string
        if (!is_null($oFPLanguage) && !is_string($oFPLanguage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($oFPLanguage, true), gettype($oFPLanguage)), __LINE__);
        }
        $this->OFPLanguage = $oFPLanguage;
        return $this;
    }
    /**
     * Get ResponseText value
     * @return string
     */
    public function getResponseText()
    {
        return $this->ResponseText;
    }
    /**
     * Set ResponseText value
     * @param string $responseText
     * @return \StructType\FINANCE_AUTHORIZATIONResult
     */
    public function setResponseText($responseText = null)
    {
        // validation for constraint: string
        if (!is_null($responseText) && !is_string($responseText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($responseText, true), gettype($responseText)), __LINE__);
        }
        $this->ResponseText = $responseText;
        return $this;
    }
    /**
     * Get Status value
     * @return string
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \StructType\FINANCE_AUTHORIZATIONResult
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get TransactionId value
     * @return string
     */
    public function getTransactionId()
    {
        return $this->TransactionId;
    }
    /**
     * Set TransactionId value
     * @param string $transactionId
     * @return \StructType\FINANCE_AUTHORIZATIONResult
     */
    public function setTransactionId($transactionId = null)
    {
        // validation for constraint: string
        if (!is_null($transactionId) && !is_string($transactionId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionId, true), gettype($transactionId)), __LINE__);
        }
        $this->TransactionId = $transactionId;
        return $this;
    }
}
