<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VIEW_BANKCARD_SETTLED_BATCH_LISTINGResult StructType
 * @subpackage Structs
 */
class VIEW_BANKCARD_SETTLED_BATCH_LISTINGResult extends AbstractStructBase
{
    /**
     * The BatchListing
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BatchListingOutput[]
     */
    public $BatchListing;
    /**
     * Constructor method for VIEW_BANKCARD_SETTLED_BATCH_LISTINGResult
     * @uses VIEW_BANKCARD_SETTLED_BATCH_LISTINGResult::setBatchListing()
     * @param \StructType\BatchListingOutput[] $batchListing
     */
    public function __construct(array $batchListing = array())
    {
        $this
            ->setBatchListing($batchListing);
    }
    /**
     * Get BatchListing value
     * @return \StructType\BatchListingOutput[]|null
     */
    public function getBatchListing()
    {
        return $this->BatchListing;
    }
    /**
     * This method is responsible for validating the values passed to the setBatchListing method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBatchListing method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBatchListingForArrayConstraintsFromSetBatchListing(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vIEW_BANKCARD_SETTLED_BATCH_LISTINGResultBatchListingItem) {
            // validation for constraint: itemType
            if (!$vIEW_BANKCARD_SETTLED_BATCH_LISTINGResultBatchListingItem instanceof \StructType\BatchListingOutput) {
                $invalidValues[] = is_object($vIEW_BANKCARD_SETTLED_BATCH_LISTINGResultBatchListingItem) ? get_class($vIEW_BANKCARD_SETTLED_BATCH_LISTINGResultBatchListingItem) : sprintf('%s(%s)', gettype($vIEW_BANKCARD_SETTLED_BATCH_LISTINGResultBatchListingItem), var_export($vIEW_BANKCARD_SETTLED_BATCH_LISTINGResultBatchListingItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The BatchListing property can only contain items of type \StructType\BatchListingOutput, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set BatchListing value
     * @throws \InvalidArgumentException
     * @param \StructType\BatchListingOutput[] $batchListing
     * @return \StructType\VIEW_BANKCARD_SETTLED_BATCH_LISTINGResult
     */
    public function setBatchListing(array $batchListing = array())
    {
        // validation for constraint: array
        if ('' !== ($batchListingArrayErrorMessage = self::validateBatchListingForArrayConstraintsFromSetBatchListing($batchListing))) {
            throw new \InvalidArgumentException($batchListingArrayErrorMessage, __LINE__);
        }
        $this->BatchListing = $batchListing;
        return $this;
    }
    /**
     * Add item to BatchListing value
     * @throws \InvalidArgumentException
     * @param \StructType\BatchListingOutput $item
     * @return \StructType\VIEW_BANKCARD_SETTLED_BATCH_LISTINGResult
     */
    public function addToBatchListing(\StructType\BatchListingOutput $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BatchListingOutput) {
            throw new \InvalidArgumentException(sprintf('The BatchListing property can only contain items of type \StructType\BatchListingOutput, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->BatchListing[] = $item;
        return $this;
    }
}
