<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VIEW_SETTLED_BATCH_SUMMARYResult StructType
 * @subpackage Structs
 */
class VIEW_SETTLED_BATCH_SUMMARYResult extends AbstractStructBase
{
    /**
     * The Batches
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\BatchesOutput[]
     */
    public $Batches;
    /**
     * Constructor method for VIEW_SETTLED_BATCH_SUMMARYResult
     * @uses VIEW_SETTLED_BATCH_SUMMARYResult::setBatches()
     * @param \StructType\BatchesOutput[] $batches
     */
    public function __construct(array $batches = array())
    {
        $this
            ->setBatches($batches);
    }
    /**
     * Get Batches value
     * @return \StructType\BatchesOutput[]|null
     */
    public function getBatches()
    {
        return $this->Batches;
    }
    /**
     * This method is responsible for validating the values passed to the setBatches method
     * This method is willingly generated in order to preserve the one-line inline validation within the setBatches method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateBatchesForArrayConstraintsFromSetBatches(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vIEW_SETTLED_BATCH_SUMMARYResultBatchesItem) {
            // validation for constraint: itemType
            if (!$vIEW_SETTLED_BATCH_SUMMARYResultBatchesItem instanceof \StructType\BatchesOutput) {
                $invalidValues[] = is_object($vIEW_SETTLED_BATCH_SUMMARYResultBatchesItem) ? get_class($vIEW_SETTLED_BATCH_SUMMARYResultBatchesItem) : sprintf('%s(%s)', gettype($vIEW_SETTLED_BATCH_SUMMARYResultBatchesItem), var_export($vIEW_SETTLED_BATCH_SUMMARYResultBatchesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Batches property can only contain items of type \StructType\BatchesOutput, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Batches value
     * @throws \InvalidArgumentException
     * @param \StructType\BatchesOutput[] $batches
     * @return \StructType\VIEW_SETTLED_BATCH_SUMMARYResult
     */
    public function setBatches(array $batches = array())
    {
        // validation for constraint: array
        if ('' !== ($batchesArrayErrorMessage = self::validateBatchesForArrayConstraintsFromSetBatches($batches))) {
            throw new \InvalidArgumentException($batchesArrayErrorMessage, __LINE__);
        }
        $this->Batches = $batches;
        return $this;
    }
    /**
     * Add item to Batches value
     * @throws \InvalidArgumentException
     * @param \StructType\BatchesOutput $item
     * @return \StructType\VIEW_SETTLED_BATCH_SUMMARYResult
     */
    public function addToBatches(\StructType\BatchesOutput $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\BatchesOutput) {
            throw new \InvalidArgumentException(sprintf('The Batches property can only contain items of type \StructType\BatchesOutput, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Batches[] = $item;
        return $this;
    }
}
